-- Author: Nerino1
-- Create Date : 4/17/2017
-- Version 1.0

local f=CreateFrame("frame");
f:RegisterEvent("PLAYER_LOGIN");
f:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED");

local level = UnitLevel("player")
local currentSpec = GetSpecialization()
local currentClass = select(2,UnitClass("player"))

table.insert(UISpecialFrames, "StatWindowFrame")

local function eventhandler(self,event)
	if event == "PLAYER_LOGIN" then
		if UnitLevel("player") <= 97 then
			statbtn:Hide()
			StatWindowFrame:Hide()
			do return end
		end
		--DEFAULT_CHAT_FRAME:AddMessage("Stat Priority Loaded.");
		StatWindowFrame:Hide()		
	end
	if event == "PLAYER_SPECIALIZATION_CHANGED" then
		currentSpec = GetSpecialization()
		GenerateStats()
	end
end

f:SetScript("OnEvent",eventhandler);

local StatWindow = CreateFrame("frame","StatWindowFrame", PaperDollFrame)
StatWindow:SetBackdrop({
      bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
      edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
      tile=1, tileSize=32, edgeSize=32, 
      insets={left=11, right=12, top=12, bottom=11}
})
StatWindow:SetWidth(215)
StatWindow:SetHeight(50)
StatWindow:SetPoint("BOTTOMRIGHT", 3, -40, PaperDollFrame)
StatWindow.text = StatWindow.text or
StatWindow:CreateFontString(nil,"OVERLAY","GameFontNormal")
StatWindow.text:SetAllPoints(true)
StatWindow.text:SetJustifyH("CENTER")
StatWindow.text:SetTextColor(1,1,1,1)

--StatWindow:EnableMouse(true)
--StatWindow:SetMovable(true)
--StatWindow:RegisterForDrag("LeftButton")
--StatWindow:SetScript("OnDragStart", function(self) self:StartMoving() end)
--StatWindow:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
--StatWindow:SetFrameStrata("FULLSCREEN_DIALOG")


local btn = CreateFrame("Button", "statbtn", PaperDollFrame, "OptionsButtonTemplate");
btn:SetPoint("BOTTOMRIGHT", -215, 10)
btn:SetText("Stat Priority")
btn:SetScript("OnClick", function() OpenStatWindow() end)

function OpenStatWindow()
	currentSpec = GetSpecialization()
	if StatWindowFrame:IsShown() then
		StatWindowFrame:Hide()
	else
		GenerateStats()
		StatWindowFrame:Show()
	end
end


function GenerateStats()
	if currentClass == "PALADIN" then
		if currentSpec == 1 then
			StatWindow.text:SetText(dataTable[1])
		elseif currentSpec == 2 then
			StatWindow.text:SetText(dataTable[2])
		elseif currentSpec == 3 then
			StatWindow.text:SetText(dataTable[3])
		end
	elseif	currentClass == "WARRIOR" then
		if currentSpec == 1 then
			StatWindow.text:SetText(dataTable[4])
		elseif currentSpec == 2 then
			StatWindow.text:SetText(dataTable[5])
		elseif currentSpec == 3 then
			StatWindow.text:SetText(dataTable[6])
		end
	elseif	currentClass == "HUNTER" then
		if currentSpec == 1 then
			StatWindow.text:SetText(dataTable[7])
		elseif currentSpec == 2 then
			StatWindow.text:SetText(dataTable[8])
		elseif currentSpec == 3 then
			StatWindow.text:SetText(dataTable[9])
		end
	elseif	currentClass == "ROGUE" then
		if currentSpec == 1 then
			StatWindow.text:SetText(dataTable[10])
		elseif currentSpec == 2 then
			StatWindow.text:SetText(dataTable[11])
		elseif currentSpec == 3 then
			StatWindow.text:SetText(dataTable[12])
		end
	elseif	currentClass == "PRIEST" then
		if currentSpec == 1 then
			StatWindow.text:SetText(dataTable[13])
		elseif currentSpec == 2 then
			StatWindow.text:SetText(dataTable[14])
		elseif currentSpec == 3 then
			StatWindow.text:SetText(dataTable[15])
		end
	elseif	currentClass == "DEATHKNIGHT" then
		if currentSpec == 1 then
			StatWindow.text:SetText(dataTable[16])
		elseif currentSpec == 2 then
			StatWindow.text:SetText(dataTable[17])
		elseif currentSpec == 3 then
			StatWindow.text:SetText(dataTable[18])
		end
	elseif	currentClass == "SHAMAN" then
		if currentSpec == 1 then
			StatWindow.text:SetText(dataTable[19])
		elseif currentSpec == 2 then
			StatWindow.text:SetText(dataTable[20])
		elseif currentSpec == 3 then
			StatWindow.text:SetText(dataTable[21])
		end
	elseif	currentClass == "MAGE" then
		if currentSpec == 1 then
			StatWindow.text:SetText(dataTable[22])
		elseif currentSpec == 2 then
			StatWindow.text:SetText(dataTable[23])
		elseif currentSpec == 3 then
			StatWindow.text:SetText(dataTable[24])
		end
	elseif	currentClass == "WARLOCK" then
		if currentSpec == 1 then
			StatWindow.text:SetText(dataTable[25])
		elseif currentSpec == 2 then
			StatWindow.text:SetText(dataTable[26])
		elseif currentSpec == 3 then
			StatWindow.text:SetText(dataTable[27])
		end
	elseif	currentClass == "MONK" then
		if currentSpec == 1 then
			StatWindow.text:SetText(dataTable[28])
		elseif currentSpec == 2 then
			StatWindow.text:SetText(dataTable[29])
		elseif currentSpec == 3 then
			StatWindow.text:SetText(dataTable[30])
		end
	elseif	currentClass == "DRUID" then
		if currentSpec == 1 then
			StatWindow.text:SetText(dataTable[31])
		elseif currentSpec == 2 then
			StatWindow.text:SetText(dataTable[32])
		elseif currentSpec == 3 then
			StatWindow.text:SetText(dataTable[33])
		elseif currentSpec == 4 then
			StatWindow.text:SetText(dataTable[34])
		end
	elseif	currentClass == "DEMONHUNTER" then
		if currentSpec == 1 then
			StatWindow.text:SetText(dataTable[35])
		elseif currentSpec == 2 then
			StatWindow.text:SetText(dataTable[36])
		end
	end	
end

dataTable = {
	[0] = "",
	[1] = "Intellect > Crit > Versatility > \n Mastery > Haste", -- Holy Paladin
	[2] = "Stamina > Haste > Versatility \n > Mastery > Crit", -- Protection Paladin
	[3] = "Strength > Haste(20-22%) > \n Crit >= Versatility > Mastery", -- Retribution Paladin
	[4] = "Mastery > Strength > Versatility > \n Haste > Crit", -- Arms Warrior
	[5] = "Strength > Haste(50%) > Mastery > \n Versatility > Crit", -- Fury Warrior
	[6] = "Strength > Haste (25-30%) > \n Versatility >= Mastery > Crit", -- Protection Warrior
	[7] = "Agility > Mastery > Haste > \n Crit > Versatility", -- Beast Mastery Hunter
	[8] = "Agility > Mastery > Crit > \n Haste > Versatility", -- Marksmanship Hunter
	[9] = "Agility > Haste > Mastery > \n Crit > Versatility", -- Survival Hunter
	[10] = "Agility > Mastery > Crit > \n Versatility > Haste", -- Assassination Rogue
	[11] = "Agility > Versatility > Crit > \n Mastery > Haste", -- Outlaw Rogue
	[12] = "Agility > Mastery > Versatility > \n Crit > Haste", -- Subtlety Rogue
	[13] = "Intellect > Haste > Crit > \n Mastery > Versatility", -- Discipline Priest
	[14] = "Intellect > Mastery > Crit > \n Haste > Versatility", -- Holy Priest
	[15] = "Haste(32%) > Mastery > Crit > \n Intellect > Haste > Versatility", -- Shadow Priest
	[16] = "Strength > Haste > \n Crit >= Versatility > Mastery", -- Blood Death Knight
	[17] = "Strength > Haste(20%) > Crit25%) \n Versatility > Mastery", -- Frost Death Knight
	[18] = "Strength > Mastery > Haste(20%) > \n Crit > Versatility", -- Unholy Death Knight
	[19] = "Intellect > Mastery(86.5%) > Crit > \n Haste > Versatility", -- Elemental Shaman
	[20] = "Agility > Mastery > Haste > \n Crit > Versatility", -- Enhancement Shaman
	[21] = "Intellect > Mastery > Crit > \n Haste > Versatility", -- Restoration Shaman
	[22] = "Intellect > Haste(22%) > Versatility(6.5%) > \n Crit > Mastery", -- Arcane Mage
	[23] = "Crit > Intellect > Mastery > \n Haste > Versatility", -- Fire Mage
	[24] = "Crit(33.3%) > Intellect > Haste > \n Versatility > Mastery", -- Frost Mage
	[25] = "Mastery > Crit > Haste > \n Intellect > Versatility", -- Affliction Warlock
	[26] = "Haste > Intellect > Crit > \n Mastery > Versatility", -- Demonology Warlock
	[27] = "Haste > Crit > Mastery > \n Intellect > Versatility", -- Destruction Warlock
	[28] = "Haste(30%) > Crit = Mastery = \n Versatility", -- Brewmaster Monk
	[29] = "Intellect > Crit > Versatility > \n Haste = Mastery", -- Mistweaver Monk
	[30] = "Agility > Mastery > \n Haste > Crit > Versatility", -- Windwalker Monk
	[31] = "Haste > Mastery > Intellect \n Crit > Versatility", -- Balance Druid
	[32] = "Agility > Mastery > Crit > \n Versatility > Haste", -- Feral Druid
	[33] = "Armor > Versatility >= Mastery > \n Haste > Agility > Crit", -- Guardian Druid
	[34] = "Intellect > Haste > Crit > \n Mastery > Versatility", -- Restoration Druid
	[35] = "Crit > Mastery > Agility > \n Haste > Versatility", -- Havoc Demon Hunter
	[36] = "Agility > Mastery > Versatility > \n Haste > Crit", -- Vengeance Demon Hunter
}